/*                                  APP.C                                  */
#include "App.h"

#define GLOBALS
#ifdef  GLOBALS
  int   Gdata=0;
  char *Gform="%5d";

/* *********************************************************************** */
   int example (void)
/* *********************************************************************** */
{ /* Beispielhafte Anwendung: */
  int  ch=' ';

  KSPinit (redisplay);
  while ((ch = KSPgetch()) != ESC)
  { Gdata = calc (Gdata); 
    KSPprintf (Gform, Gdata); 
  }
  return (Gdata);
}

/* *********************************************************************** */
   int redisplay (void) 
/* *********************************************************************** */
{ /* Anpassung an Plattform-Vorgaben: */
  int j1=MAX((Gdata-KSPLINES),0);

  while (j1 < Gdata)
  { j1= calc (j1);  KSPprintf (Gform, j1); 
  }
  return (j1);
}

#else //GLOBALS

/* *********************************************************************** */
   void common (char **form, int **data) 
/* *********************************************************************** */
{ /* Eliminierung globaler Variablen: */
  static char _form[80]="";
  static int  _data=0;

  *form=_form; *data=&_data; 

  sprintf(*form, "%%5d"); /*Achtung: 2mal "%", da Steuerzeichen!*/
//sprintf(*form, "%s", "%5d"); // Alternative Formulierung 
  return;
}

/* *********************************************************************** */
   int example (void)
/* *********************************************************************** */
{ /* Beispielhafte Anwendung: */
  static char *form=NULL;
  static int  *data=NULL;
  int  ch=' ';

  if (!form || !data) common (&form, &data); 
  KSPinit (redisplay);
  while ((ch = KSPgetch()) != ESC)
  { *data = calc (*data); 
    KSPprintf (form, *data); 
  }
  return (*data);
}

/* *********************************************************************** */
   int redisplay (void) 
/* *********************************************************************** */
{ /* Anpassung an Plattform-Vorgaben: */
  static char *form=NULL;
  static int  *data=NULL;
  int j1=0;

  if (!form || !data) common (&form, &data); 
  j1=MAX((*data-KSPLINES),0);
  while (j1 < *data)
  { j1= calc (j1);  KSPprintf (form, j1); 
  }
  return (j1);
}
#endif//GLOBALS

/* *********************************************************************** */
   int calc (int num) 
/* *********************************************************************** */
{ /* Fachlich relevanter Programmteil */
  return (++num);
}

/* *********************************************************************** */
   int main (void)
/* *********************************************************************** */
{ /* Zu Testzwecken: */
  printf ("\n\r       Aris Christidis:");
  printf ("\n\r       Programm  zur  Zaehlung  von  Tastenanschlaegen");
  printf ("\n\r       Zahlenkolonne mit 's'/'d' links/rechts verschieben!");
  printf ("\n\r       Beendigung mit <Esc> ");
#ifdef  MIT_TIMER
  printf ("- nach 30 sec automatisch");
#endif  MIT_TIMER
  printf ("\n\n\n\n(mit bel. Taste weiter)\n"); 
  _getch(); 
  system (CLS); 

  example ();
  return (1);
}
 